<?php

class Andy_NewPostLimit_ControllerPublic_Thread extends XFCP_Andy_NewPostLimit_ControllerPublic_Thread
{
	public function actionIndex()
	{	
		// get parent
		$parent = parent::actionIndex();
		
		// get user information
		$user = XenForo_Visitor::getInstance();
		
		// declare variable
		$bypass = '';		
		
		// get options from Admin CP -> Options -> New Post Limit -> Exclude Secondary Groups
		$excludeSecondaryGroups = XenForo_Application::get('options')->newPostLimitExcludeSecondaryGroups;
		
		if ($excludeSecondaryGroups != '')
		{
			// remove trailing comma
			$excludeSecondaryGroups = rtrim($excludeSecondaryGroups, ',');				
			
			// create excludeSecondaryGroupArray
			$excludeSecondaryGroupsArray = explode(',', $excludeSecondaryGroups);
			
			// create secondary_group_ids_array
			$secondary_group_ids_array = explode(',', $user['secondary_group_ids']);	
			
			// check for excluded secondary user groups
			foreach ($excludeSecondaryGroupsArray as $value) 
			{
				if (in_array($value, $secondary_group_ids_array)) 
				{
					$bypass = 'yes';
				}
			}
		}
		
		// get options from Admin CP -> Options -> New Post Limit -> Exclude Users
		$excludeUsers = XenForo_Application::get('options')->newPostLimitExcludeUsers;
		
		if ($excludeUsers != '')
		{
			// remove trailing comma
			$excludeUsers = rtrim($excludeUsers, ',');				
			
			// create excludeUsersArray
			$excludeUsersArray = explode(',', $excludeUsers);
			
			// check for excluded users
			foreach ($excludeUsersArray as $value) 
			{
				if ($value == $user['user_id'])
				{
					$bypass = 'yes';
				}
			}
		}			

		// continue if bypass does not equal yes
		if ($bypass != 'yes')
		{
			// get options from Admin CP -> Options -> New Post Limit -> New Post Maximum
			$newPostMaximum = XenForo_Application::get('options')->newPostLimitNewPostMaximum;			
			
			// get options from Admin CP -> Options -> New Post Limit -> Days
			$days = XenForo_Application::get('options')->newPostLimitDays;		
			
			// convert to Unix timesatmp
			$timestamp = time() - (86400 * $days);		
			
			// get database
			$db = XenForo_Application::get('db');
			
			// get newPostCount
			$newPostCount = $db->fetchOne("
			SELECT COUNT(post_id)
			FROM xf_post
			WHERE user_id = ?
			AND post_date > ?
			", array($user['user_id'], $timestamp));	
			
			if ($newPostCount >= $newPostMaximum)
			{
				// add denyReply to parent params
				$parent->params['denyReply'] = true;					
			}
		}
				
		// return parent
		return $parent;
	}
}